<template>
	<v-container class="sampling-collection-create flex-grow-1">
		<!-- :class="{ 'px-0': $vuetify.breakpoint.smAndDown }" -->
		<v-skeleton-loader v-if="!isReady" type="card" min-height="500px" />
		<div v-else-if="hasError" rounded="lg">
			<v-card-text> Error loading</v-card-text>
		</div>
		<div v-else rounded="lg" class="overflow-hidden flex-grow-1">
			<!-- <v-card-text> -->
			<!-- {{ fieldId }}
				<br />
				{{ locationCollectionId }} -->

			<div class="text-h6">Select sample depths</div>
			<p class="text-body-1">Each soil core (sampling) will be split into samples for these depth ranges.</p>

			<p></p>
			<div class="error--text">
				{{ errors }}
			</div>
			<depths-form class="mb-3" :items="depths" @setDepths="onSetDepths" />
			<v-spacer />
			<v-btn color="primary" large rounded block class="px-4" @click="startClickHandler" :disabled="!!errors">
				Start
			</v-btn>
			<!-- </v-card-text> -->
		</div>
	</v-container>
</template>

<script lang="ts">
import { defineComponent, ref, Ref, computed, ComputedRef } from '@vue/composition-api';
import { SamplingCollection, SoDepth } from '@/store/types';
import ObjectId from 'bson-objectid';
import DepthsForm from '@/components/forms/DepthsForm/DepthsForm.vue';

function createSamplingCollection({
	id,
	fieldId,
	locationCollectionId,
	sampleDepths,
}: {
	id: string;
	fieldId: string;
	locationCollectionId: string;
	sampleDepths: SoDepth[];
}): SamplingCollection {
	// const minDepth = sampleDepths.reduce((r: number, x: SoDepth) => {
	// 	const sorted = Object.values(x)
	// 		.map((y) => y.value)
	// 		.sort();
	// 	const min = sorted[0];
	// 	return min < r ? min : r;
	// }, 1e6);
	const minDepth = 0;
	const maxDepth = sampleDepths.reduce((r: number, x: SoDepth) => {
		const sorted = Object.values(x)
			.map((y) => y.value)
			.sort();
		const max = sorted[sorted.length - 1];
		return max > r ? max : r;
	}, 0);
	const soDepth = {
		minValue: {
			value: minDepth,
			unit: 'unit:CM',
		},
		maxValue: {
			value: maxDepth,
			unit: 'unit:CM',
		},
	};
	return {
		id,
		name: 'Sampling Collection',
		object: locationCollectionId,
		featureOfInterest: fieldId,
		members: [],
		soDepth,
		sampleDepths,
		dateCreated: new Date().toISOString(),
		dateModified: new Date().toISOString(),
	};
}

export default defineComponent({
	components: {
		DepthsForm,
	},
	setup(props, { root }) {
		const hasError = ref(false);
		const isReady = ref(false);

		const fieldId = root.$route.query.field as string;
		const locationCollectionId = root.$route.query.object as string;
		if (!fieldId || !locationCollectionId) {
			hasError.value = true;
		}

		const depths: Ref<SoDepth[]> = ref([
			{
				minValue: {
					value: 0,
					unit: 'unit:CM',
				},
				maxValue: {
					value: 0,
					unit: 'unit:CM',
				},
			},
		]);
		function onSetDepths(value: SoDepth[]) {
			depths.value = value;
		}

		function depthsIsValid(items: SoDepth[]): boolean | string {
			if (!items.length) {
				return 'Must include at least one sample depth';
			}

			if (items.some((d) => d.minValue.value >= d.maxValue.value)) {
				return 'Max depth must be greater than min depth';
			}

			return true;
		}
		// const errors: Ref<string[]> = ref([]);
		const errors: ComputedRef<string | false | null> = computed(() => {
			const result = depthsIsValid(depths.value);
			return result !== true ? result : null;
		});

		async function startClickHandler() {
			if (depthsIsValid(depths.value) === true) {
				const id = new ObjectId().toHexString();
				const newRecord = createSamplingCollection({
					id,
					fieldId: fieldId || '',
					locationCollectionId: locationCollectionId || '',
					sampleDepths: depths.value,
				});
				await root.$store.dispatch('samplingCollections/setRecord', newRecord);
				root.$router.push(`/sampling-collection/${id}/edit`);
			}
		}

		isReady.value = true;

		return {
			hasError,
			isReady,
			fieldId,
			locationCollectionId,
			startClickHandler,
			depths,
			onSetDepths,
			errors,
		};
	},
});
</script>

<style></style>
